<?php

/*
	importsource_swinhr - import source for Swinburne HR extracts
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once(RESOURCE_DIR . 'includes/identity.inc.php');
require_once(RESOURCE_DIR . 'includes/importsource.inc.php');
require_once(BLUESTONE_DIR . 'utf8_string.inc.php');

class importsource_nicnamesxml extends importsource
{
	static function getname()
	{
		return "NicNames XML file";
	}

	function __construct($filename)
	{
		$this->loadxml($filename);

		$this->valid = 
			$this->validxml
			&& $this->root->nodeName == 'nicnames';

		$this->index = 0;
	}

	function isvalid()
	{
		return $this->valid;
	}

	function getnextidentity()
		// gets next identity, or NULL if there are no more identities
	{
		if (!$this->validxml) return null;

		do
		{
			do
			{
				if ($this->index >= $this->root->childNodes->length) return NULL;
				$node = $this->root->childNodes->item($this->index++);
			}
			while ($node->nodeType != XML_ELEMENT_NODE || $node->tagName != 'identity');

			$identity = new identity();
			$identity->setfromXML($node);

			$identity->anonymise();
			$errors = $identity->validate();
		}
		while (!empty($errors)); // skip over any identities which don't
		// validate.  at the moment, this means that if there is a problem with an
		// identity you're importing, the only way you'll know is the count of imported
		// identities will be lower than expected.


		return $identity;
	}
}

?>
