<?php

/*
	identity_alias - a class that represents a deleted/merged identity
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

class identity_alias
{
	public $id = null;
	public $resolution;
	public $refid = null; // reference to merged identity id if merged
	public $createddate = null;
	public $lastmodifieddate = TIMENOW;

	function getXML($document = null, $elementname = 'stub')
	// Create a DomElement object representing this identity
	{
		if ($document===null) $document = new DomDocument();
		$el = $document->createElement($elementname);
		
		if ($this->id) $el->setAttribute('id', $this->id);
		$el->setAttribute('resolution', $this->resolution);
		if ($this->refid) $el->setAttribute('refid', $this->refid);
		 	$el->setAttribute('createddate', gmdate("Y-m-d\TH:i:s\Z", $this->createddate));
		if ($this->lastmodifieddate) 
			$el->setAttribute('lastmodifieddate', gmdate("Y-m-d\TH:i:s\Z", $this->lastmodifieddate));
		return $el;
	}

	function stripprivate()
	{
	}

	function getrendered()
	{
		$output = array(
			array(
				'title' => 'Identity ' . $this->resolution,
				'post-qualifier' => date('j M, Y', $this->createddate),
				'resolution' => $this->resolution,
				'refid' => $this->refid,
				),
			);

		return $output;
	}

	/*
	function setfromXML($el)
	// populate this object with properties from the supplied DOM XML element
	{
		if ($el->hasAttribute('id')) $this->id = $el->getAttribute('id');
		if ($el->hasAttribute('resolution')) $this->resolution = $el->getAttribute('resolution');
		if ($el->hasAttribute('refid')) $this->refid = $el->getAttribute('refid');
		if ($el->hasAttribute('createddate')) $this->createddate = strtotime($el->getAttribute('createddate'));
		if ($el->hasAttribute('lastmodifieddate')) $this->lastmodifieddate = strtotime($el->getAttribute('lastmodifieddate'));
	}
	 */
}

?>
