<?php

/*
	importsource - abstract base class for importing identity records from some source
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once(RESOURCE_DIR . 'includes/identity.inc.php');

class importsource
{
	static function getname()
		// override this with a friendly name for this importer.  Tip: don't include the
		// word 'importer' at the end.
	{
		return null;
	}

	static function expectsfile()
		// return false if this importer does not expect an input file - for example, if it
		// imports via a call to an external server instead.  For historical reasons this
		// should always default to true.
	{
		return true;
	}

	function isvalid()
		// this should return TRUE if the import source is valid, false otherwise
	{
		return false;
	}

	function getnextidentity()
		// gets next identity, or NULL if there are no more identities
	{
		return null;
	}

	function getoutput()
		// if your importer is also an exporter - ie if it processes a file and returns
		// an output file - you should return its contents here.  otherwise this should
		// return null
	{
		return null;
	}

	protected function loadxml($filename)
	{
		$this->validxml = false;
		$this->doc = new DomDocument();
		if (!$this->doc->load($filename, LIBXML_NOWARNING | LIBXML_NOERROR)) return false;
		if (!($this->root = $this->doc->documentElement)) return false;
		return $this->validxml = true;
	}
}

?>
