<?php

/*
	action_installer - an installer module which sets up the database, etc
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

class action_install extends module
{
	function display()
	{
		$this->template->vars['title'] = 'Install';
		if (!$this->fullaccess) return $this->denyaccess('run the installer');

		$doinstall = $this->context->load_var('agreeinstall', 'POST', 'yesno');

		if ($doinstall) return $this->doinstall();

		$this->maxage = 86400;
		return $this->template->runtemplate('action_install');
	}

	function doinstall()
	{
		if (!$this->fullaccess) return $this->denyaccess('run the installer');
		$this->warnings = false;

		$this->startrealtime();
		$this->template->vars['pagetitle'] = 'Initialising or repairing your installation...';
		$this->outputrealtime($this->template->runtemplate('progresswin_head'));
		$this->outputrealtime($this->template->runtemplate('action_install_start'));

		$diagnostics = $this->controls->getcontrol('diagnostics');
		$status = $diagnostics->preinstall(array($this, 'seterror'));
		if ($status)
		{
			$this->seterror('Pre-install checks complete.', 'notice');

			$dbinit = $this->controls->getcontrol('dbinit');
			$status = $dbinit->preparetables(array($this, 'seterror'));
			$this->seterror('Finished setting up database tables.', 'notice');

			$status = $diagnostics->postinstall(array($this, 'seterror'));
			if ($status)
			{
				$this->seterror('Post-install diagnostics complete.', 'notice');
			}
		}

		$this->template->vars['action_success'] = $status;
		$this->outputrealtime($this->template->runtemplate('action_install_end'));
		$this->outputrealtime($this->template->runtemplate('progresswin_foot'));
	}

	function seterror($message, $type)
	{
		$this->template->vars['action_errormessage'] = $message;
		$this->template->vars['action_errortype'] = $type;
		$this->outputrealtime($this->template->runtemplate('action_install_updateprogress'));
		if ($type == 'warning' || $type == 'error') $this->warnings = true;
	}
}

?>
