<?php

/*
	action_query - module for conducting searches
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

class action_moderate extends module
{
	function display()
	{
		$this->template->vars['title'] = 'Records needing attention';

		// messages
		$m = $this->context->load_var('m', 'REQUEST', 'name');
		if ($m == 'markedverifiedsuccess') $this->template->vars['notices'][] = 'The selected identities were successfully marked as verified and removed from the list.';

		// when choosing a status, the status is stored in a cookie for later
		// use.  this is a session cookie only.
		$status = $this->context->load_var('status', 'REQUEST', 'name');
		if ($status === null)
			$status = $this->context->load_var('action_moderate_status', 'COOKIE', 'string');
		else
			$this->context->setcookie('action_moderate_status', $status);

		if ($status === null) $status = 'nomatch';

		$this->statuses = array(
			'nomatch' => 'new identities',
			'uncertainmatch' => 'updated identities flagged by the system',
			'requestedverification' => 'identities with unverified information',
		);
		$this->template->vars['action_status'] = $this->vars['status'] = $status;
		$this->template->vars['action_statuses'] = $this->vars['statuses'] = $this->statuses;

		if (!isset($this->statuses[$status])) $status = 'normal';

		if ($this->context->load_var("verify", 'REQUEST', 'yesno'))
			return $this->verifyconfirm($status);
		else return $this->showidentities($status);
	}

	function showidentities($status)
	{
		$fetchidentities = $this->controls->getcontrol('fetchidentities');

		$statusids = $statuscounts = array();
		foreach ($this->statuses as $statusind => $desc)
		{
			$statuslists[$statusind] = $fetchidentities->getidsbystatus($statusind, true);
			$statuscounts[$statusind] = count($statuslists[$statusind]);
		}

		$this->identities = $this->layoutidentities($statuslists[$status]);

		$this->template->vars['action_statuscounts'] = $this->vars['statuscounts'] = $statuscounts;

		if (!$this->fullaccess)
		{
			$this->maxage = 900;
			$this->vary = 'Cookie';
		}
		if ($this->format == 'html')
			return $this->template->runtemplate('action_moderate');
	}

	function verifyconfirm($status)
	{
		if (!$this->fullaccess) return $this->denyaccess('mark identities as verified');
		$cutoff = $this->context->load_var('cutoff', 'REQUEST', 'int');

		if ($this->context->load_var('result_markverified', 'POST', 'yesno'))
		{
			$editidentity = $this->controls->getcontrol('editidentity');
			$result = $editidentity->markallverified($status, $cutoff);

			if (!$result)
			{
				$this->vars['error'] = 'nomatches';
				$this->template->vars['notices'][] = "No matching identities were found, so no changes have been made.";
			}
			else
				$this->context->redirect(URL_PATH . "?a=moderate&status=$status&f={$this->format}&m=markedverifiedsuccess");
		}

		$fetchidentities = $this->controls->getcontrol('fetchidentities');
		$count = $fetchidentities->getcountbystatus($status, $cutoff);

		$this->template->vars['action_statuscount'] = $this->vars['statuscount'] = $count;
		$this->template->vars['action_cutoff'] = $this->vars['statuscutoff'] = $cutoff;

		return $this->template->runtemplate('action_moderate_verifyconfirm');
	}
}

?>
