<?php

/*
	action_query - module for conducting searches
	Copyright (c) 2009
	
	This file is part of NicNames.
	
	NicNames is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as 
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.
	
	NicNames is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with NicNames.  If not, see <http://www.gnu.org/licenses/>.
*/

class action_query extends module
{
	function display()
	{
		$m = $this->context->load_var('m', 'REQUEST', 'name');
		if ($m == 'deleteidentitysuccess')
			$this->template->vars['notices'][] = 'The identity you chose was successfully deleted.';
		if ($m) $this->vars['message'] = $m;

		$queryperformed = false;
		$searchurl = '?a=query';
		$searchdesk = null;

		$time = $this->context->load_var("modifiedsince", 'REQUEST', 'string');
		if ($time)
		{
			$cutoff = (int)strtotime($time);
			$fetchidentities = $this->controls->getcontrol('fetchidentities');
			$ids = $fetchidentities->getidsmodifiedsince($cutoff);
			$this->identities = $this->layoutidentities($ids);
			$queryperformed = true;
			$searchurl = "?a=query&modifiedsince=" . urlencode(gmdate("Y-m-d\TH:i:s\Z", $cutoff));
			$searchdesc = "records modified since " . date('j M Y', $cutoff);
			$timeofday = date('H:i:s', $cutoff);
			if ($timeofday != '00:00:00') $searchdesc .= " ($timeofday)";
		}
		else
		{
			$this->identities = $this->findidentities();
			$queryperformed = $this->querystring != '';
			$searchurl = "?a=query&query=" . urlencode($this->querystring);
			$searchdesc = $this->querystring;
		}

		$this->template->vars['title'] = 'Search';
		$this->template->vars['action_queryperformed'] = $queryperformed;
		$this->template->vars['action_searchurl'] = $searchurl;
		$this->template->vars['action_searchdesc'] = $searchdesc; 

		// client-side cache up to 15 minutes for public access, 30 seconds for admin
		if (!$time) $this->maxage = $this->fullaccess ? 30 : 900;
		$this->vary = 'Cookie';
		if (!$queryperformed) $this->maxage = 86400;

		if ($this->format == 'html')
			return $this->template->runtemplate('action_query');
	}
}

?>
