

<h1>OAI-PMH access</h1>

<p>This NicNames database may be harvested using an OAI-PMH harvester.  Please configure your harvester to use one of the following base addresses.</p>

<ul>
<li>For public access: <code><?php echo $action_publicaddress; ?></code></li>
<li>For admin access: <code><?php echo $action_adminaddress; ?></code></li>
</ul>

<p>Admin access grants access to information that may have been hidden from public view, and is intended for authorised access within an institution's own systems.</p>
<p>Note that typically, admin access will require HTTP Basic authentication or may be limited by IP address, depending on how NicNames has been installed.</p>

<h2>OAI-PMH Features</h2>
<p>NicNames supports all the minimum requirements for an OAI-PMH repository.  In addition, it also supports:</p>
<ul>
	<li>Persistent reporting of deleted records.</li>
	<li>Choice of metadata formats.</li>
	<li>Modification datestamps accurate to 1 second.</li>
</ul>

<h2>Notes to harvesters</h2>

<ol>
<li>The harvests may contain records representing both identities affiliated with this institution, and those that aren't - either because their affiliation has ceased or they are a non-affiliated identity.
Each record's metadata will indicate whether an identity is affiliated or not.
Whether a NicNames database contains non-affiliated identities, and why, is implementation-specific.</li>
<li>As required by the OAI-PMH specification, each record is available in the "oai_dc" format.
This is a basic format which allows only unqualified Dublin core fields, and is not very good at representing information about an identity.
To get a more complete representation of each record, use the "nicnames" format, the <a href="<?php echo $action_publicaddress . "nicnames.xsd"; ?>">schema</a> for which includes some basic documentation.
</li>
<li>
Some records in the NicNames database may contain data that has not been verified, or which has been added automatically by a matching algorithm.  This can be determined by the "verified" and "status" attributes throughout the "nicnames" metadata format.  It is not necessary to do anything with these, but they exist so that you may make a judgement about the reliability of the information.  No such information exists in the "oai_dc" metadata format.
</li>
<li>NicNames supports its own native method for harvesting as an alternative to OAI-PMH.  Please see the API documentation for more details.  While the feature set is pretty similar, there are a few benefits, such as the ability to retrieve records which match a search term, and to get records in either XML or JSON format.</li>
</ol>
