<?php

require_once(dirname(__FILE__) . '/../resources/global.inc.php');
require_once(RESOURCE_DIR . '../tests/libraries/simpletest/autorun.php');

require_once(RESOURCE_DIR . '../tests/dbtest.inc.php');

class IndexLookupTest extends DatabaseIntegrationTestCase
{
	function testgetcontrol()
	{
		$this->indexlookup = &$this->controls->getcontrol('indexlookup');
		$this->assertTrue($this->indexlookup);

	}

	function testindexlookup()
	{
		// seed with identity
		
		$identity1 = new identity();
		$name = new name();
		$name->surname = "smith";
		$name->givennames = "tony russell";
		$name->type = "birthname";
		$identity1->names[] = $name;

		$identity2 = new identity();
		$name = new name();
		$name->surname = "roberts";
		$name->givennames = "julia drew";
		$name->type = "publishedasname";
		$identity2->names[] = $name;

		$editidentity = $this->controls->getcontrol('editidentity');
		$editidentity->updateidentity($identity1);
		$editidentity->updateidentity($identity2);

		$matches = $this->indexlookup->besteffortmatch('five smith tony quick brown fox');
		$this->assertNotEqual(count($matches), 0);
		$this->assertEqual(reset($matches), $identity1->id); // closest match should be first

		$matches = $this->indexlookup->besteffortmatch('juila droo quick brown fox');
		$this->assertNotEqual(count($matches), 0);
		$this->assertEqual(reset($matches), $identity2->id);

		$matches = $this->indexlookup->grammaticalmatch('juila droo');
		$this->assertNotEqual(count($matches), 0);
		$this->assertEqual(reset($matches), $identity2->id);

		$matchidentity = new identity();
		$name = new name();
		$name->surname = "smith";
		$this->givennames = "antony rusell";
		$name->type = "birthname";
		$matchidentity->names[] = $name;

		$matches = $this->indexlookup->findmatches($matchidentity);
		$this->assertNotEqual(count($matches), 0);
		$this->assertEqual(reset($matches), $identity1->id);
	}
}

?>
